<template>
  <div>
    <el-card style="margin-top: -15px">
      <el-form :model="filterQuery" label-width="120px" v-show="showSearch">
        <el-row>
          <el-col :span="6">
            <el-form-item label="单据号:" class="query-form-item">
              <el-input v-model="filterQuery.billNo" style="width: 90%" placeholder="单据号" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="单据日期:" class="query-form-item">
              <el-date-picker
                :picker-options="pickerOptions"
                v-model="actDateRange"
                type="daterange"
                style="width: 90%"
                format="yyyy 年 MM 月 dd 日"
                value-format="yyyy-MM-dd"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>


      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-search" @click="onSubmitFind">查询</el-button>
          <el-button type="primary" icon="el-icon-plus" @click="combine">确定</el-button>
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>
      <el-table v-loading="loading" :data="list" style="width: 100%" border highlight-current-row
                @current-change="handleDetail">
        <el-table-column label="序号" type="index" width="60"></el-table-column>
        <el-table-column label="单据号" prop="billNo"></el-table-column>
        <el-table-column label="申购日期" prop="billDate">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.billDate, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="创建人" prop="createByName"></el-table-column>
        <el-table-column label="审核人" prop="auditByName"></el-table-column>
        <el-table-column label="申购仓库" prop="invName"></el-table-column>
        <el-table-column label="申购分库" prop="subInvName"></el-table-column>
        <el-table-column label="申购说明" prop="remark"></el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="filterQuery.page"
        :limit.sync="filterQuery.limit"
        @pagination="handleCurrentChange"

      ></pagination>

    </el-card>
    <el-card class="el-card">
      <el-table v-loading="loading" :data="detailList" style="width: 100%" border highlight-current-row>
        <el-table-column label="序号" type="index" width="120"></el-table-column>
        <el-table-column label="产品通用名" prop="productName" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="规格型号" prop="spec" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="申购数量" prop="count"></el-table-column>
        <el-table-column label="注册/备案凭证号" prop="zczbhhzbapzbh" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="生产企业" prop="manufactory" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="医疗器械注册人" prop="ylqxzcrbarmc" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="供应商" prop="supName" show-overflow-tooltip="true"></el-table-column>
      </el-table>
    </el-card>
  </div>
</template>

<script>
import pureApplyDetail from "./purPlanDetailDialog";
import {selectApprovedList,listApplyDetail} from "@/api/purchase/purPlan"
import {delOrder, addPlanDetailAndOrder,listOrderDetail} from "@/api/purchase/purOrder"

export default {
  name: "selectPlanListDialog",
  props: {
    data: {
      type: Object,
      required: true,
    },
    closeDialog: {
      type: Function,
      required: true,
    },
    pId: {
      type: Object,
      required: true,
    },
  },

  data() {
    return {
      showSearch: true,
      filterQuery: {

        billAction: null,
        billNo: "",
        originType: null,
        page: 1,
        limit: 10,
      },
      formName: null,
      statusMap: {
        1: "草稿",
        2: "未审核",
        3: "已审核",
        4: "已拒绝"
      },
      ids: [],
      idQuery: {},
      editType: 2,
      total: 0,
      thirdSys: [],
      thirdSysDetail: null,
      busTypes: [],
      originTypes: [],
      list: [],
      detailList: [],
      loading: false,
      currentRow: null,
      actDateRange: [],
      selectApplyVisible:false,
      newSpDistributionVisible: false,
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.filterQuery = {
        billNo: "",
        thirdSysFk: "",
        billFlag: null,
        billAction: null,
        startDate: null,
        endDate: null,
        page: 1,
        limit: 10,
        corpName: null,
        type: 1,
        editStatus: 1,
      };
      this.actDateRange = [];
      this.getList();
    },

    onSubmitFind() {
      this.filterQuery.page = 1;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    getList() {
      if (this.actDateRange != null) {
        this.filterQuery.startDate = this.actDateRange[0];
        this.filterQuery.endDate = this.actDateRange[1];
      } else {
        this.filterQuery.startDate = null;
        this.filterQuery.endDate = null;
      }
      this.loading = true;
      this.filterQuery.status = 3;
      selectApprovedList(this.filterQuery)
        .then((response) => {
          if (response.code == 20000) {
            this.list = response.data.list || [];
            this.total = response.data.total || 0;
          } else {
            this.$message.error(response.message);
          }
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    handleDetail(row) {
      this.currentRow = row;
      let query = {orderIdFk: row.id};
      this.loading = true;
      listApplyDetail(query) //查找该单号下的所有条码
        .then((response) => {
          this.detailList = response.data.list || [];
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
          this.detailList = [];
          this.total = 0;
        });
    },
    deleteDialog(row) {
      this.$confirm("此操作将永久删除该单据, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          delOrder(row.id)
            .then((response) => {
              this.loading = false;
              if (response.code == 20000) {
                this.$message.success("删除成功");
                this.getList();
              } else {
                this.$message.error(response.message);
              }
            })
            .catch(() => {
              this.loading = false;
            });

        })
        .catch(() => {
        });
    },
    handleCurrentChange(val) {
      this.filterQuery.page = val.page;
      this.getList();
    },

    combine() {
      if (this.$isBlank(this.currentRow.id)) {
        this.$message.error("未选择申购单！");
      }

      var data = {
        id: this.pId,
        applyId: this.currentRow.id
      }
      addPlanDetailAndOrder(data).then((res) => {
          this.closeDialog(res.data);
      }).catch(() => {

      })


    },


  },
  created() {
    let end = new Date();
    let start = new Date();
    start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
    this.actDateRange = [start, end];
    this.getList();

    this.ids = [];
    if (this.data.stockOrderLists.length > 0) {
      for (var i = 0; i < this.data.stockOrderLists.length; i++) {
        this.ids.push(this.data.stockOrderLists[i].productId);
      }
    }

  },
  components: {
    pureApplyDetail
  },


  filters: {
    statusFilterType(status) {
      const statusMap = {
        2: "warning",
        3: "success",
        4: "danger",
      };
      return statusMap[status];
    }
    ,
  }
  ,


};
</script>

<style scoped>

div /deep/ .el-table .warning-row {
  background: #bebebe;
}

div /deep/ .el-table .success-row {
  background: #ffffff;
}
</style>
